#!/bin/sh
# $Id: check.sh,v 1.1 1996/05/19 09:05:47 src Exp $
#
# very simple test script
# much work needs to be done here
#
SPOOL=check.spool
HOST=localhost
NEWSGROUP=impossible.group
NEWSPATH=impossible/group
ID="12345@${HOST}"

rm -f check.log check.folder check.stdout check.stderr 
rm -f ${SPOOL}/out.going/${HOST}/LOCKb

echo "begin"
#
# make a dummy news spool
#
mkdir -p ${SPOOL}/${NEWSPATH}
(
    echo "Xref: ${HOST} ${NEWSGROUP}:1"
    echo "Newsgroups: ${NEWSGROUP}"
    echo "Path: ${HOST}!usenet"
    echo "NNTP-Posting-Host: ${HOST}!usenet"
    echo "Message-ID: <${ID}>"
    echo "Subject: Test"
    echo ""
    echo "This is strange:"
    echo "."
    echo "From for instance"
) > ${SPOOL}/${NEWSPATH}/1

#
# outgoing batch, Cnews mode
#
mkdir -p ${SPOOL}/out.going/${HOST}
(
    echo "${NEWSPATH}/1"
) > ${SPOOL}/out.going/${HOST}/togo

echo "do check"

#
# do the check without a socket connection
#
./postit -ddd -n -s ${SPOOL} -f check.folder -l check.log ${HOST} > check.stdout 2> check.stderr

if [ `cat check.stdout | wc -l` -ne 0 ] ; then
	echo "Output on stdout"
	exit 1
fi
if [ `cat check.folder | wc -l` -ne 9 ] ; then
	echo "Bad folder"
	exit 1
fi
if [ `cat check.log | wc -l` -ne 1 ] ; then
	echo "Bad log file size"
	exit 1
fi
if ! grep -q "${HOST} <${ID}> ${NEWSPATH}/1 TEST" check.log ; then
	echo "Bad log file entry"
	exit 1
fi
if ! grep -q "server: ${HOST}, spool: ${HOST}" check.stderr ; then
	echo "Line 1 missing"
	exit 1
fi
if ! grep -q "created lock: ${SPOOL}/out.going/${HOST}/LOCKb" check.stderr ; then
	echo "Line 2 missing"
	exit 1
fi
if ! grep -q "opened spool file: ${SPOOL}/out.going/${HOST}/togo" check.stderr ; then
	echo "Line 3 missing"
	exit 1
fi

echo "fake OK..."

#
#create Cnews lock file
#
echo "1" > ${SPOOL}/out.going/${HOST}/LOCKb

#
# do the check with locking
#
echo "try w/locking..."

./postit -ddd -n -t 1 -s ${SPOOL} -f check.folder -l check.log ${HOST} > check.stdout 2> check.stderr

echo "OK w/locking..."

#
# do the check properly
#
echo "Check posting to ${HOST}, hang on..."
./postit -ddd -s ${SPOOL} -f check.folder -l check.log ${HOST} >> check.stdout 2>> check.stderr

echo "OK"
exit 0
